package sun.tracing;

import java.util.Iterator;
import java.util.HashSet;
import com.sun.tracing.Provider;
import java.util.Set;
import com.sun.tracing.ProviderFactory;

public class MultiplexProviderFactory extends ProviderFactory
{
    private Set<ProviderFactory> factories;
    
    public MultiplexProviderFactory(Set<ProviderFactory> factories) {
        this.factories = factories;
    }
    
    public <T extends Provider> T createProvider(Class<T> clazz) {
        HashSet<Provider> set = new HashSet();
        Iterator<ProviderFactory> iterator = this.factories.iterator();
        while (iterator.hasNext()) {
            set.add(((ProviderFactory)iterator.next()).createProvider(clazz));
        }
        MultiplexProvider o = new MultiplexProvider(clazz, set);
        o.init();
        return o.newProxyInstance();
    }
}
